define(['require', 'app'],
    function(require, APP) {
        /**
         * Controller for CargarOrdenes generated by Appery.io
         * @module CargarOrdenes
         */
        APP.controller('CargarOrdenes', ['$scope', 'Apperyio', controller]);

        function controller($scope, Apperyio) {
            /**
             * user controller variables
             */
            $scope.parseLines = Apperyio.EntityAPI('String');
            $scope.ordenesActual = Apperyio.EntityAPI('Number');
            $scope.ordenesTotal = Apperyio.EntityAPI('Number');
            $scope.finCargaNube = Apperyio.EntityAPI('Boolean');
            $scope.marcaOption = Apperyio.EntityAPI('String');
            $scope.customMarkers = Apperyio.EntityAPI('String');
            $scope.selectFechaAsignacion = Apperyio.EntityAPI('String');
            $scope.ordenesAnteriores = Apperyio.EntityAPI('Ordenes');
            $scope.parseLinesAs = Apperyio.EntityAPI('String');
            /**
             * User controller functions
             */
            /**
             * @function init
             */
            $scope.init = function() {
                //On load screen logic
                $scope.minFechaSelect = formatDateNow2($scope.diasSeleccionCalendarioRetro);
                $scope.parseLines = [];
                $scope.parseLinesAs = [];
                $scope.ordenesTotal = 0;
                $scope.ordenesActual = 0;
                $scope.customMarkers = {};
                $scope.selectFechaAsignacionDefault = formatDateNow2(0);
                $scope.disableProcesarOrdenes = true;
                $scope.disableInputText = false;
                $scope.datosEmpresa = JSON.parse(localStorage.getItem("companyData"));
                $scope.estadoOp = JSON.parse(localStorage.getItem("diasOperacion"));
                $scope.usuario = JSON.parse(localStorage.getItem("userData"));
                $scope.ordenesAnteriores = [];
                $scope.ordenesAnterioresArrAsoc = {};
                $scope.disableDateAssign = false;
                $scope.ignorarDuplicados = false;
                $scope.usarAsignaciones = true;
                $scope.mensajeActProceso = "";
                $scope.statusCarga = false;
                $scope.detenerProcesoC = false;
                $scope.contadorOk = 0;
                $scope.contadorWarn = 0;
                $scope.contadorErr = 0;
                $scope.totalOkStatus = false;
                $scope.totalErrStatus = false;
                $scope.totalWarnStatus = false;
                $scope.totalOkMsg = "";
                $scope.totalErrMsg = "";
                $scope.totalWarnMsg = "";
                $scope.msgFinProceso = "";
                $scope.msgResumenProceso = "";
                $scope.totalOrdenesAsignacion = 0;
                $scope.totalInvocacionesGPS = 0;
                $scope.totalOrdenesNuevas = 0;
                $scope.totalOrdenesActualizadas = 0;
                $scope.totalOrdenesAsignacionCoincidentes = 0;
                $scope.listaOrdenesAsignacionNoCoincidentes = "";
                $scope.hayNoCargadas = false;
                //Obtenemos los templates de formulario
                $scope.companyData = JSON.parse(localStorage.getItem("companyData"));
                $scope.templateForms = {};
                if ($scope.companyData.config.formTypes) {
                    for (var i in $scope.companyData.config.formTypes) {
                        form = $scope.companyData.config.formTypes[i];
                        if (form.data.operationData) {
                            $scope.templateForms[form.formType + form.formSubType] = form.data.operationData;
                        } else if (form.data.referenceData) {
                            //Buscamos en el arreglo el tipo subtipo de referencia
                            for (var j in $scope.companyData.config.formTypes) {
                                form2 = $scope.companyData.config.formTypes[j];
                                if (form2.formType == form.data.referenceData.formType && form2.formSubType == form.data.referenceData.formSubType && form2.data) {
                                    if (form2.data.operationData) {
                                        $scope.templateForms[form.formType + form.formSubType] = form2.data.operationData;
                                    } else {
                                        $scope.templateForms[form.formType + form.formSubType] = null;
                                    }
                                    break;
                                }
                            }
                        } else {
                            $scope.templateForms[form.formType + form.formSubType] = null;
                        }
                    }
                }
                $scope.arrParseColumns = {
                    "orden de servicio No": "codigo",
                    "Nombre del Cliente": "nombreCliente",
                    "fecha de la solicictud": "fechaSolicitud",
                    "Request Time": "horaSolicitud",
                    "Comentarios": "mensajeCliente",
                    "Customer Comment": "investigacion",
                    "Calle": "direccion",
                    "Barrio": "comuna",
                    "Ciudad": "ciudad",
                    "Estado": "region",
                    "No de telefono(home)": "telefonoClienteHome",
                    "No de telefono(office)": "telefonoClienteOffice",
                    "No de telefono(mobile)": "telefonoClienteMobile",
                    "ASC 1st Appointment Date": "fechaEstimadaDia",
                    "ASC 1st Appointment Time": "fechaEstimadaHora",
                    "Codigo del Ingeniero": "idOperador",
                    "fecha de compra": "fechaCompra",
                    "Tipo de Servicio": "tipoServicio",
                    "In Out Warranty Flag": "subTipoServicio",
                    "Modelo": "modelo",
                    "Nro de Serie": "serie",
                    "Descripcion del Defecto": "descripcionDefecto",
                    "Descripcion de la reparacion": "descripcionReparacion",
                    "Estado Code": "estadoCarga",
                    "Parte No01": "c1",
                    "Partes solicitadas description 01": "n1",
                    "Parte No02": "c2",
                    "Partes solicitadas description 02": "n2",
                    "Parte No03": "c3",
                    "Partes solicitadas description 03": "n3",
                    "Parte No04": "c4",
                    "Partes solicitadas description 04": "n4",
                    "Parte No05": "c5",
                    "Partes solicitadas description 05": "n5",
                    "Parte No06": "c6",
                    "Partes solicitadas description 06": "n6",
                    "Parte No07": "c7",
                    "Partes solicitadas description 07": "n7",
                    "Parte No08": "c8",
                    "Partes solicitadas description 08": "n8",
                    "Parte No09": "c9",
                    "Partes solicitadas description 09": "n9",
                    "Parte No10": "c10",
                    "Partes solicitadas description 10": "n10",
                };
                $scope.arrErrorCodeTranscription = {
                    "DBSC217": "El código de orden ya existe en el sistema",
                    "DBSC230": "Formato de fecha incorrecto"
                };
                $scope.imagenesStatusCarga = {
                    "CA": "files/images/cargando.gif",
                    "OK": "files/images/ok.png",
                    "ER": "files/images/error.png",
                };
            };
            /**
             * @function readFromExcel
             */
            $scope.readFromExcel = function() {
                $scope.parseLines = [];
                $scope.parseLines = parseDataTable($scope.textOrders);
                $scope.finCargaNube = false;
                $scope.ordenesTotal = $scope.parseLines.length;
                if ($scope.parseLines.length > 0) {
                    $scope.disableProcesarOrdenes = false;
                    for (var i in $scope.parseLines) {
                        $scope.parseLines[i].estCargando = false;
                        $scope.parseLines[i].estOk = false;
                        $scope.parseLines[i].estError = false;
                        $scope.parseLines[i].fechaAsignacionData = $scope.selectFechaAsignacionModelo ? formatDate3($scope.selectFechaAsignacionModelo.toISOString()) : formatDateNow2(0);
                        $scope.parseLines[i].repuestos = "";
                        $scope.parseLines[i].repuestosArr = [];
                        coma = "";
                        for (j = 1; j <= 10; ++j) {
                            if ($scope.parseLines[i]["c" + j]) {
                                $scope.parseLines[i].repuestosArr.push({
                                    "type": "check",
                                    "order": 1,
                                    "align": "inline",
                                    "name": $scope.parseLines[i]["c" + j] + ", " + $scope.parseLines[i]["n" + j]
                                });
                                $scope.parseLines[i].repuestos += coma + $scope.parseLines[i]["c" + j] + ": " + $scope.parseLines[i]["n" + j];
                                coma = ", ";
                            }
                        }
                    }
                }
            };
            /**
             * @function parseDataTable
             * @param dataTable
             */
            function parseDataTable(dataTable) {
                var parseDataReturn = [];
                var parseLines = dataTable.split("\n");
                esHeader = true;
                for (var i in parseLines) {
                    if (esHeader) {
                        arrayHeader = [];
                        parseTabs = parseLines[i].split("\t");
                        for (var j in parseTabs) {
                            arrayHeader.push(changeNameColumns(parseTabs[j]));
                        }
                        esHeader = false;
                    } else {
                        var row = {};
                        parseTabs = parseLines[i].split("\t");
                        for (var j in parseTabs) {
                            row[arrayHeader[j]] = parseTabs[j];
                        }
                        parseDataReturn.push(row);
                    }
                }
                //Eliminar registros duplicados
                var arrTmp = [];
                var elementosDuplicados = false;
                for (var i = 0; i < parseDataReturn.length; ++i) {
                    if (!arrTmp.includes(parseDataReturn[i].codigo)) {
                        arrTmp.push(parseDataReturn[i].codigo);
                    } else {
                        elementosDuplicados = true;
                        parseDataReturn.splice(i, 1);
                        i--;
                    }
                }
                if (elementosDuplicados) {
                    $scope.mAlert("Se encontró registros duplicados en el listado de órdenes. Sólo se procesará un regsitro por orden");
                }
                return parseDataReturn;
            };
            /**
             * @function descargar
             */
            $scope.descargar = function() {
                tableToExcel('dataTable', 'Ordenes');
            };
            /**
             * @function claenTable
             */
            $scope.claenTable = function() {
                $scope.textOrders = "";
                $scope.textAsignaciones = "";
                $scope.parseLines = [];
                $scope.parseLinesAs = [];
                $scope.customMarkers = {};
                $scope.ordenesTotal = 0;
                $scope.ordenesActual = 0;
                $scope.finCargaNube = false;
                $scope.disableProcesarOrdenes = true;
                $scope.ordenesAnteriores = [];
                $scope.ordenesAnterioresArrAsoc = {};
                $scope.disableDateAssign = false;
                $scope.disableInputText = false;
                $scope.mensajeActProceso = "";
                $scope.statusCarga = false;
                $scope.contadorOk = 0;
                $scope.contadorWarn = 0;
                $scope.contadorErr = 0;
                $scope.totalOkStatus = false;
                $scope.totalErrStatus = false;
                $scope.totalWarnStatus = false;
                $scope.totalOkMsg = "";
                $scope.totalErrMsg = "";
                $scope.totalWarnMsg = "";
                $scope.msgFinProceso = "";
                $scope.msgResumenProceso = "";
                $scope.totalOrdenesAsignacion = 0;
                $scope.totalInvocacionesGPS = 0;
                $scope.totalOrdenesNuevas = 0;
                $scope.totalOrdenesActualizadas = 0;
                $scope.totalOrdenesAsignacionCoincidentes = 0;
                $scope.listaOrdenesAsignacionNoCoincidentes = "";
                $scope.hayNoCargadas = false;
            };
            /**
             * @function myAlert
             */
            $scope.myAlert = function() {
                alert(1);
            };
            /**
             * @function test
             */
            $scope.test = function() {
                alert($scope.fileCarga);
            };
            /**
             * @function cargarOrdenes
             */
            $scope.cargarOrdenes = function() {
                //Validar asignaciones antes de comenzar
                var ordenesFinalACargar = $scope.ordenesTotal;
                if ($scope.usarAsignaciones) {
                    if ($scope.parseLinesAs.length === 0) {
                        $scope.mAlert("No ha cargado asignaciones. \nSi desea cargar todas las órdenes del listado, debe desmarcar el indicador \"Usar Asignaciones\"");
                        return;
                    } else {
                        //Dejamos en asignaciones sólo las que tengan la marca check
                        for (var i = 0; i < $scope.parseLinesAs.length; ++i) {
                            if (!$scope.parseLinesAs[i].checkAssign) {
                                $scope.parseLinesAs.splice(i, 1);
                                --i;
                            }
                        }
                        //Se debe eliminar los elementos que no estén en parseLinesAs
                        ordenesFinalACargar = 0;
                        for (var i = 0; i < $scope.parseLines.length; ++i) {
                            var encontrado = false;
                            for (var j = 0; j < $scope.parseLinesAs.length; ++j) {
                                if ($scope.parseLines[i].codigo.trim() == $scope.parseLinesAs[j].codigo.trim()) {
                                    encontrado = true;
                                    ordenesFinalACargar++;
                                    //Actualizamos el dato del código del operador en el arreglo original
                                    //Por decisión de HES 28/03/2019
                                    //Ahora manda siempre el dato de la ASIGNACION
                                    $scope.parseLines[i].idOperador = $scope.parseLinesAs[j].id;
                                    break;
                                }
                            }
                            //$scope.parseLines[i].cargarAsignaciones = encontrado;
                            if (!encontrado) {
                                $scope.parseLines.splice(i, 1);
                                i--;
                            }
                        }
                        //Obtener las órdenes no coincidentes
                        $scope.listaOrdenesAsignacionNoCoincidentes = "";
                        var coma = "";
                        for (var j = 0; j < $scope.parseLinesAs.length; ++j) {
                            var encontrado = false;
                            for (var i = 0; i < $scope.parseLines.length; ++i) {
                                if ($scope.parseLines[i].codigo.trim() == $scope.parseLinesAs[j].codigo.trim()) {
                                    encontrado = true;
                                    break;
                                }
                            }
                            if (!encontrado) {
                                $scope.listaOrdenesAsignacionNoCoincidentes += coma + $scope.parseLinesAs[j].codigo.trim();
                                coma = ", ";
                            }
                        }
                    }
                } else {
                    if (!confirm("Ha indicado NO usar asignaciones. El sistema cargará TODAS las órdenes del listado. \n¿Desea continuar de todas maneras?")) {
                        return;
                    }
                }
                var listaOrdenesFinalCargar = [];
                for (var i in $scope.parseLines) {
                    listaOrdenesFinalCargar.push($scope.parseLines[i].codigo);
                }
                $scope.ordenesTotal = ordenesFinalACargar;
                $scope.totalOrdenesAsignacionCoincidentes = $scope.ordenesTotal;
                if (confirm("Ud. va a cargar " + ordenesFinalACargar + " órdenes al sistema. Este proceso podria tardar varios minutos.\n¿Desea continuar?")) {
                    if ($scope.parseLines.length > 0) {
                        $scope.disableDateAssign = true;
                        $scope.statusCarga = true;
                        //Me traigo una cierta cantidad de órdenes para chequear si existen previamente
                        var limiteOrdenesAnteriores = 1000;
                        $scope.ordenesAnterioresArrAsoc = {};
                        $scope.showLoading("Recuperando órdenes anteriores...");
                        var requestData = {};
                        requestData = (function mapping7163($scope) {
                            var requestData = {};
                            requestData.params = {};
                            requestData.params.where = {
                                "$and": [{
                                        "companyId": $scope.datosEmpresa.idCliente
                                    },
                                    {
                                        "documentCode": {
                                            "$in": listaOrdenesFinalCargar
                                        }
                                    }
                                ]
                            };
                            requestData.params["sort"] = "-_updatedAt";
                            requestData.params["limit"] = limiteOrdenesAnteriores;
                            return requestData;
                            /*CLICK TO EDIT MAPPING*/
                        })($scope);
                        // read more about using rest services: https://links.appery.io/ve-snippet-rest
                        Apperyio.get("Tech1_WORKORDER_query_service")(requestData).then(
                            function(success) { // success callback
                                (function mapping9884(success, $scope) {
                                    var ordenesAnteriores_scope = $scope.ordenesAnteriores;
                                    for (var i = 0, l = success.data.length; i < l; i++) {
                                        _.set(ordenesAnteriores_scope, '[' + i + '].codigo', success.data[i].documentCode);
                                        _.set(ordenesAnteriores_scope, '[' + i + '].marca', success.data[i].productAntecedent.marca);
                                        _.set(ordenesAnteriores_scope, '[' + i + '].estado', success.data[i].documentStatus);
                                        _.set(ordenesAnteriores_scope, '[' + i + ']._id', success.data[i]._id);
                                        _.set(ordenesAnteriores_scope, '[' + i + '].assignmentLocation', success.data[i].assignmentLocation);
                                        if (success.data[i].assignmentLocation) {
                                            $scope.customMarkers[success.data[i].documentCode] = success.data[i].assignmentLocation;
                                        }
                                    }
                                    $scope.ordenesAnteriores = ordenesAnteriores_scope;
                                    for (var j in $scope.ordenesAnteriores) {
                                        $scope.ordenesAnterioresArrAsoc[$scope.ordenesAnteriores[j].codigo] = $scope.ordenesAnteriores[j];
                                    }
                                    /*CLICK TO EDIT MAPPING*/
                                })(success, $scope);
                                $scope.disableProcesarOrdenes = true;
                                $scope.disableInputText = true;
                                $scope.ordenesActual = 0;
                                $scope.stopLoading();
                                cargaPrevioExistenciaOrden(0);
                            },
                            function(error) { // callback to handle request error
                                $scope.stopLoading();
                                alert("Hubo problemas al recuperar las órdenes anteriores: " + error.data.code + " " + error.data.description);
                            },
                            function(notify) { // notify callback, can fire few times
                            });
                    } else {
                        alert("No hay órdenes para cargar");
                    }
                }
            };
            /**
             * @function cargaPrevioExistenciaOrden
             * @param parseLinesIter
             */
            function cargaPrevioExistenciaOrden(parseLinesIter) {
                //Validar si se intenó detener el proceso de carga
                if ($scope.detenerProcesoC) {
                    $scope.mensajeActProceso = "Se ha detenido el proceso de carga!";
                    $scope.textOrders = "";
                    $scope.textAsignaciones = "";
                    showstatusFinProc();
                    $scope.detenerProcesoC = false;
                    return;
                }
                //Recorrer el arreglo de ordenes
                $scope.parseLines[parseLinesIter].estCargando = true;
                $scope.parseLines[parseLinesIter].estOk = false;
                $scope.parseLines[parseLinesIter].estError = false;
                $scope.parseLines[parseLinesIter].estWarning = false;
                //Chequear disponibilidad de la fecha
                var fechaCarga = $scope.parseLines[parseLinesIter]["fechaAsignacionDataModel"] ? formatDate3($scope.parseLines[parseLinesIter]["fechaAsignacionDataModel"].toISOString()) : $scope.parseLines[parseLinesIter]["fechaAsignacionData"];
                //Chequear disponibilidad de la fecha para carga
                if (existeFechaProceso($scope.estadoOp, fechaCarga)) {
                    $scope.contadorErr++;
                    $scope.parseLines[parseLinesIter].estCargando = false;
                    $scope.parseLines[parseLinesIter].estOk = false;
                    $scope.parseLines[parseLinesIter].estError = true;
                    $scope.hayNoCargadas = true;
                    $scope.parseLines[parseLinesIter].estWarning = false;
                    $scope.parseLines[parseLinesIter].codigoError = "ERR03";
                    $scope.parseLines[parseLinesIter].textoError = "La Fecha de Asignación " + invierteFecha(fechaCarga) + " para la orden " + $scope.parseLines[parseLinesIter].codigo + " ya se encuentra asignada";
                    $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                    $scope.ordenesActual++;
                    if ($scope.ordenesActual >= $scope.ordenesTotal) {
                        $scope.textOrders = "";
                        $scope.textAsignaciones = "";
                        showstatusFinProc();
                    } else {
                        cargaPrevioExistenciaOrden(parseLinesIter + 1);
                    }
                    return;
                }
                //Chequear existencia de Operador asignado
                if (!$scope.parseLines[parseLinesIter].idOperador) {
                    $scope.contadorErr++;
                    $scope.parseLines[parseLinesIter].estCargando = false;
                    $scope.parseLines[parseLinesIter].estOk = false;
                    $scope.parseLines[parseLinesIter].estError = true;
                    $scope.hayNoCargadas = true;
                    $scope.parseLines[parseLinesIter].estWarning = false;
                    $scope.parseLines[parseLinesIter].codigoError = "ERR13";
                    $scope.parseLines[parseLinesIter].textoError = "No viene operador asignado para la orden " + $scope.parseLines[parseLinesIter].codigo;
                    $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                    $scope.ordenesActual++;
                    if ($scope.ordenesActual >= $scope.ordenesTotal) {
                        $scope.textOrders = "";
                        $scope.textAsignaciones = "";
                        showstatusFinProc();
                    } else {
                        cargaPrevioExistenciaOrden(parseLinesIter + 1);
                    }
                    return;
                }
                //Chequear estado de carga remota aceptado
                if (!$scope.estadosCargaPermitidos.includes($scope.parseLines[parseLinesIter].estadoCarga) && !confirm("La orden " + $scope.parseLines[parseLinesIter].codigo + " no está en un estado válido para cargar al sistema (" + $scope.parseLines[parseLinesIter].estadoCarga + ").\n¿Desea cargar la orden de todas maneras?")) {
                    $scope.contadorErr++;
                    $scope.parseLines[parseLinesIter].estCargando = false;
                    $scope.parseLines[parseLinesIter].estOk = false;
                    $scope.parseLines[parseLinesIter].estError = true;
                    $scope.hayNoCargadas = true;
                    $scope.parseLines[parseLinesIter].estWarning = false;
                    $scope.parseLines[parseLinesIter].codigoError = "ERR04";
                    $scope.parseLines[parseLinesIter].textoError = "La orden " + $scope.parseLines[parseLinesIter].codigo + " NO está en estado válido para cargar al sistema";
                    $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                    $scope.ordenesActual++;
                    if ($scope.ordenesActual >= $scope.ordenesTotal) {
                        $scope.textOrders = "";
                        $scope.textAsignaciones = "";
                        showstatusFinProc();
                    } else {
                        cargaPrevioExistenciaOrden(parseLinesIter + 1);
                    }
                    return;
                }
                //Chequear existencia template de formulario para el tipo/subtipo
                if (!$scope.templateForms[$scope.parseLines[parseLinesIter].tipoServicio + $scope.parseLines[parseLinesIter].subTipoServicio]) {
                    $scope.contadorErr++;
                    $scope.parseLines[parseLinesIter].estCargando = false;
                    $scope.parseLines[parseLinesIter].estOk = false;
                    $scope.parseLines[parseLinesIter].estError = true;
                    $scope.hayNoCargadas = true;
                    $scope.parseLines[parseLinesIter].estWarning = false;
                    $scope.parseLines[parseLinesIter].codigoError = "ERR07";
                    $scope.parseLines[parseLinesIter].textoError = "El tipo de orden " + $scope.parseLines[parseLinesIter].tipoServicio + "/" + $scope.parseLines[parseLinesIter].subTipoServicio + " para la orden " + $scope.parseLines[parseLinesIter].codigo + " no tiene un template de carga definido";
                    $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                    $scope.ordenesActual++;
                    if ($scope.ordenesActual >= $scope.ordenesTotal) {
                        $scope.textOrders = "";
                        $scope.textAsignaciones = "";
                        showstatusFinProc();
                    } else {
                        cargaPrevioExistenciaOrden(parseLinesIter + 1);
                    }
                    return;
                }
                //Chequear estado de la orden y existencia
                if (existePrevio($scope.parseLines[parseLinesIter].codigo)) {
                    if ($scope.ignorarDuplicados) {
                        $scope.contadorErr++;
                        $scope.parseLines[parseLinesIter].estCargando = false;
                        $scope.parseLines[parseLinesIter].estOk = false;
                        $scope.parseLines[parseLinesIter].estError = true;
                        $scope.hayNoCargadas = true;
                        $scope.parseLines[parseLinesIter].estWarning = false;
                        $scope.parseLines[parseLinesIter].codigoError = "ERR06";
                        $scope.parseLines[parseLinesIter].textoError = "La orden " + $scope.parseLines[parseLinesIter].codigo + " ya existe en el sistema.";
                        $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                        $scope.ordenesActual++;
                        if ($scope.ordenesActual >= $scope.ordenesTotal) {
                            $scope.textOrders = "";
                            $scope.textAsignaciones = "";
                            showstatusFinProc();
                        } else {
                            cargaPrevioExistenciaOrden(parseLinesIter + 1);
                        }
                        return;
                    } else {
                        if ($scope.ordenesAnterioresArrAsoc[$scope.parseLines[parseLinesIter].codigo].estado == "2" || $scope.ordenesAnterioresArrAsoc[$scope.parseLines[parseLinesIter].codigo].estado == "3") {
                            $scope.contadorErr++;
                            $scope.parseLines[parseLinesIter].estCargando = false;
                            $scope.parseLines[parseLinesIter].estOk = false;
                            $scope.parseLines[parseLinesIter].estError = true;
                            $scope.hayNoCargadas = true;
                            $scope.parseLines[parseLinesIter].estWarning = false;
                            $scope.parseLines[parseLinesIter].codigoError = "ERR01";
                            $scope.parseLines[parseLinesIter].textoError = "La orden " + $scope.parseLines[parseLinesIter].codigo + " está asignada/trabajo en el sistema y no puede ser modificada";
                            $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                            $scope.ordenesActual++;
                            if ($scope.ordenesActual >= $scope.ordenesTotal) {
                                $scope.textOrders = "";
                                $scope.textAsignaciones = "";
                                showstatusFinProc();
                            } else {
                                cargaPrevioExistenciaOrden(parseLinesIter + 1);
                            }
                            return;
                        } else {
                            if ($scope.ordenesAnterioresArrAsoc[$scope.parseLines[parseLinesIter].codigo].estado == "4") {
                                if ($scope.mConfirm("La orden " + $scope.parseLines[parseLinesIter].codigo + " ya está FINALIZDA en el sistema, si continúa, la información de cierre de la orden se perderá.\n¿Desea sobreescribir la información de la orden?")) {
                                    //Eliminamos la original
                                    var requestData = {};
                                    requestData.params = {};
                                    requestData.params._id = $scope.ordenesAnterioresArrAsoc[$scope.parseLines[parseLinesIter].codigo]._id;
                                    /*CLICK TO EDIT MAPPING*/
                                    // read more about using rest services: https://links.appery.io/ve-snippet-rest
                                    Apperyio.get("Tech1_WORKORDER_delete_service")(requestData).then(
                                        function(success) { // success callback
                                            /*CLICK TO EDIT MAPPING*/
                                            $scope.totalOrdenesActualizadas++;
                                            cargaUbicacionesUnaPorUna(parseLinesIter);
                                            return;
                                        },
                                        function(error) { // callback to handle request error
                                            if (!$scope.parseLines[parseLinesIter].estWarning) {
                                                $scope.contadorErr++;
                                                $scope.parseLines[parseLinesIter].estCargando = false;
                                                $scope.parseLines[parseLinesIter].estOk = false;
                                                $scope.parseLines[parseLinesIter].estError = true;
                                                $scope.hayNoCargadas = true;
                                                $scope.parseLines[parseLinesIter].estWarning = false;
                                                $scope.parseLines[parseLinesIter].codigoError = error.data.code;
                                                $scope.parseLines[parseLinesIter].textoError = (decodeErrorCodes(error.data.code) !== "" ? decodeErrorCodes(error.data.code) : error.data.description);
                                                $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                                            }
                                            $scope.ordenesActual++;
                                            if ($scope.ordenesActual >= $scope.ordenesTotal) {
                                                $scope.textOrders = "";
                                                $scope.textAsignaciones = "";
                                                showstatusFinProc();
                                            } else {
                                                cargaPrevioExistenciaOrden(parseLinesIter + 1);
                                            }
                                            return;
                                        },
                                        function(notify) { // notify callback, can fire few times
                                        });
                                } else {
                                    $scope.contadorErr++;
                                    $scope.parseLines[parseLinesIter].estCargando = false;
                                    $scope.parseLines[parseLinesIter].estOk = false;
                                    $scope.parseLines[parseLinesIter].estError = true;
                                    $scope.hayNoCargadas = true;
                                    $scope.parseLines[parseLinesIter].estWarning = false;
                                    $scope.parseLines[parseLinesIter].codigoError = "ERR07";
                                    $scope.parseLines[parseLinesIter].textoError = "La orden " + $scope.parseLines[parseLinesIter].codigo + " ya está FINALIZADA en el sistema.";
                                    $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                                    $scope.ordenesActual++;
                                    if ($scope.ordenesActual >= $scope.ordenesTotal) {
                                        $scope.textOrders = "";
                                        $scope.textAsignaciones = "";
                                        showstatusFinProc();
                                    } else {
                                        cargaPrevioExistenciaOrden(parseLinesIter + 1);
                                    }
                                    return;
                                }
                            } else {
                                //Eliminamos la original
                                var requestData = {};
                                requestData.params = {};
                                requestData.params._id = $scope.ordenesAnterioresArrAsoc[$scope.parseLines[parseLinesIter].codigo]._id;
                                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                                Apperyio.get("Tech1_WORKORDER_delete_service")(requestData).then(
                                    function(success) { // success callback
                                        $scope.totalOrdenesActualizadas++;
                                        cargaUbicacionesUnaPorUna(parseLinesIter);
                                        return;
                                    },
                                    function(error) { // callback to handle request error
                                        if (!$scope.parseLines[parseLinesIter].estWarning) {
                                            $scope.contadorErr++;
                                            $scope.parseLines[parseLinesIter].estCargando = false;
                                            $scope.parseLines[parseLinesIter].estOk = false;
                                            $scope.parseLines[parseLinesIter].estError = true;
                                            $scope.hayNoCargadas = true;
                                            $scope.parseLines[parseLinesIter].estWarning = false;
                                            $scope.parseLines[parseLinesIter].codigoError = error.data.code;
                                            $scope.parseLines[parseLinesIter].textoError = (decodeErrorCodes(error.data.code) !== "" ? decodeErrorCodes(error.data.code) : error.data.description);
                                            $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                                        }
                                        $scope.ordenesActual++;
                                        if ($scope.ordenesActual >= $scope.ordenesTotal) {
                                            $scope.textOrders = "";
                                            $scope.textAsignaciones = "";
                                            showstatusFinProc();
                                        } else {
                                            cargaPrevioExistenciaOrden(parseLinesIter + 1);
                                        }
                                        return;
                                    },
                                    function(notify) { // notify callback, can fire few times
                                    });
                            }
                        }
                    }
                } else {
                    cargaUbicacionesUnaPorUna(parseLinesIter);
                }
            };
            /**
             * @function cargaUbicacionesUnaPorUna
             * @param parseLinesIter
             */
            function cargaUbicacionesUnaPorUna(parseLinesIter) {
                //Si existe la posición GPS, se usa la guardada
                if ($scope.customMarkers[$scope.parseLines[parseLinesIter].codigo] && $scope.customMarkers[$scope.parseLines[parseLinesIter].codigo].id) {
                    cargarOrdenesCloudPorUna(parseLinesIter);
                } else {
                    var requestDataLoc = {
                        params: {
                            address: $scope.parseLines[parseLinesIter].direccion + ", " + $scope.parseLines[parseLinesIter].comuna + ", " + $scope.parseLines[parseLinesIter].ciudad + ", " + $scope.regionesDecode[$scope.parseLines[parseLinesIter].region] + ", " + $scope.paisDefault
                        }
                    };
                    $scope.totalInvocacionesGPS++;
                    Apperyio.get("GetGeoLocationFromAddress_service")(requestDataLoc).then(
                        function(success) {
                            if (success.data.results.length > 0) {
                                //Evaluar si la posición retornada está dentro del rango cuadrante permitido
                                if (success.data.results[0].geometry.location.lat <= $scope.limitGPSPositionTopLeft.latitude &&
                                    success.data.results[0].geometry.location.lat >= $scope.limitGPSPositionBottomRight.latitude &&
                                    success.data.results[0].geometry.location.lng >= $scope.limitGPSPositionTopLeft.longitude &&
                                    success.data.results[0].geometry.location.lng <= $scope.limitGPSPositionBottomRight.longitude) {
                                    var marker = {};
                                    marker.id = success.data.results[0].place_id;
                                    marker.title = success.data.results[0].formatted_address;
                                    //marker.coords = {};
                                    marker.latitude = success.data.results[0].geometry.location.lat;
                                    marker.longitude = success.data.results[0].geometry.location.lng;
                                    $scope.customMarkers[$scope.parseLines[parseLinesIter].codigo] = marker;
                                    cargarOrdenesCloudPorUna(parseLinesIter);
                                } else {
                                    var marker = {};
                                    $scope.customMarkers[success.config.params.order] = marker;
                                    $scope.contadorWarn++;
                                    $scope.parseLines[parseLinesIter].estCargando = false;
                                    $scope.parseLines[parseLinesIter].estOk = false;
                                    $scope.parseLines[parseLinesIter].estError = false;
                                    $scope.parseLines[parseLinesIter].estWarning = true;
                                    $scope.parseLines[parseLinesIter].codigoError = "POS03";
                                    $scope.parseLines[parseLinesIter].textoError = "El punto de Geolocalización (latitud: " + success.data.results[0].geometry.location.lat + ", longitud: " + success.data.results[0].geometry.location.lng + ") está fuera del área de cobertura. Deberá ser corregido manualmente";
                                    $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                                    cargarOrdenesCloudPorUna(parseLinesIter);
                                }
                            } else {
                                var marker = {};
                                $scope.customMarkers[success.config.params.order] = marker;
                                $scope.contadorWarn++;
                                $scope.parseLines[parseLinesIter].estCargando = false;
                                $scope.parseLines[parseLinesIter].estOk = false;
                                $scope.parseLines[parseLinesIter].estError = false;
                                $scope.parseLines[parseLinesIter].estWarning = true;
                                $scope.parseLines[parseLinesIter].codigoError = "POS01";
                                $scope.parseLines[parseLinesIter].textoError = "No se ha podido obtener la Geolocalización. Deberá ser corregido manualmente";
                                $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                                cargarOrdenesCloudPorUna(parseLinesIter);
                            }
                        },
                        function(error) {
                            var marker = {};
                            $scope.customMarkers[error.config.params.order] = marker;
                            $scope.contadorWarn++;
                            $scope.parseLines[parseLinesIter].estCargando = false;
                            $scope.parseLines[parseLinesIter].estOk = false;
                            $scope.parseLines[parseLinesIter].estError = false;
                            $scope.parseLines[parseLinesIter].estWarning = true;
                            $scope.parseLines[parseLinesIter].codigoError = "POS02";
                            $scope.parseLines[parseLinesIter].textoError = "No se ha podido obtener la Geolocalización. Deberá ser corregido manualmente";
                            $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                            cargarOrdenesCloudPorUna(parseLinesIter);
                        }
                    );
                }
            };
            /**
             * @function cargarOrdenesCloudPorUna
             * @param parseLinesIter
             */
            function cargarOrdenesCloudPorUna(parseLinesIter) {
                //Recorrer el arreglo de ordenes
                //$scope.parseLines[parseLinesIter].codigoError = "";
                //$scope.parseLines[parseLinesIter].textoError = "";
                var requestData = {};
                requestData = (function mapping7267($scope) {
                    var requestData = {};
                    requestData.data = {};
                    var parseLines_scope = $scope.parseLines[parseLinesIter];
                    //_.set(requestData.data, 'marca', ($scope.marcaOption?$scope.marcaOption:parseLines_scope["marca"]));
                    _.set(requestData.data, 'documentCode', parseLines_scope["codigo"]);
                    fields = [];
                    fields.push({
                        "key": "Fecha de Compra",
                        "value": formatDate1(parseLines_scope["fechaCompra"])
                    });
                    fields.push({
                        "key": "Marca",
                        "value": "SAMSUNG"
                    });
                    fields.push({
                        "key": "Artículo",
                        "value": "Modelo: " + parseLines_scope["modelo"] + ", Serie (IMEI): " + parseLines_scope["serie"]
                    });
                    _.set(requestData.data, 'productAntecedent', {
                        "fields": fields
                    });
                    fields = [];
                    fields.push({
                        "key": "Nombre",
                        "value": parseLines_scope["nombreCliente"]
                    });
                    fields.push({
                        "key": "Comentario",
                        "value": parseLines_scope["mensajeCliente"]
                    });
                    fields.push({
                        "key": "Dirección",
                        "value": parseLines_scope["direccion"]
                    });
                    fields.push({
                        "key": "Comuna",
                        "value": parseLines_scope["comuna"]
                    });
                    _.set(requestData.data, 'receiverAntecedent', {
                        "fields": fields
                    });
                    _.set(requestData.data, 'requestDate', formatDate1(parseLines_scope["fechaSolicitud"]) + " " + parseLines_scope["horaSolicitud"]);
                    //        _.set(requestData.data, 'fechaAsignacion', createDate1(parseLines_scope["fechaAsignacionDataModel"]?formatDate3(parseLines_scope["fechaAsignacionDataModel"].toISOString()):parseLines_scope["fechaAsignacionData"]));
                    _.set(requestData.data, 'assignmentDate', parseLines_scope["fechaAsignacionDataModel"] ? formatDate3(parseLines_scope["fechaAsignacionDataModel"].toISOString()) : parseLines_scope["fechaAsignacionData"]);
                    //        _.set(requestData.data, 'sequence', parseLinesIter);
                    _.set(requestData.data, 'documentStatus', 1);
                    //        _.set(requestData.data, 'mensajeCliente', parseLines_scope["mensajeCliente"]);
                    //        _.set(requestData.data, 'direccion', parseLines_scope["direccion"]);
                    //        _.set(requestData.data, 'comuna', parseLines_scope["comuna"]);
                    _.set(requestData.data, 'receiverContact', {
                        "phone": {
                            "Movil": parseLines_scope["telefonoClienteMobile"],
                            "Casa": parseLines_scope["telefonoClienteHome"],
                            "Oficina": parseLines_scope["telefonoClienteOffice"]
                        }
                    });
                    //        _.set(requestData.data, 'fechaEstimada', formatDate1(parseLines_scope["fechaEstimadaDia"])+" "+parseLines_scope["fechaEstimadaHora"]);
                    _.set(requestData.data, 'operatorCode', parseLines_scope["idOperador"]);
                    //        _.set(requestData.data, 'fechaCompra', formatDate1(parseLines_scope["fechaCompra"]));
                    _.set(requestData.data, 'formType', parseLines_scope["tipoServicio"]);
                    _.set(requestData.data, 'formSubType', parseLines_scope["subTipoServicio"]);
                    fields = [];
                    fields.push({
                        "key": "Descripción del Defecto",
                        "value": parseLines_scope["descripcionDefecto"]
                    });
                    fields.push({
                        "key": "Descripción de la Reparación",
                        "value": parseLines_scope["descripcionReparacion"]
                    });
                    fields.push({
                        "key": "Investigación",
                        "value": parseLines_scope["investigacion"]
                    });
                    _.set(requestData.data, 'previousDiagnosis', {
                        "fields": fields
                    });
                    //        _.set(requestData.data, 'descripcionReparacion', parseLines_scope["descripcionReparacion"]);
                    //        _.set(requestData.data, 'articulo', "Modelo: "+parseLines_scope["modelo"]+", Serie (IMEI): " + parseLines_scope["serie"]);
                    //        _.set(requestData.data, 'investigacion', parseLines_scope["investigacion"]);
                    _.set(requestData.data, 'companyId', $scope.datosEmpresa.idCliente);
                    _.set(requestData.data, 'assignmentLocation', $scope.customMarkers[parseLines_scope["codigo"]]);
                    //        var operationData = JSON.parse(JSON.stringify($scope.formsTemplate[parseLines_scope["tipoServicio"]+parseLines_scope["subTipoServicio"]]));
                    var operationData = JSON.parse(JSON.stringify($scope.templateForms[parseLines_scope["tipoServicio"] + parseLines_scope["subTipoServicio"]]));
                    //Agregamos los repuestos
                    if (parseLines_scope.repuestosArr && operationData) {
                        for (var i in operationData.form) {
                            if (operationData.form[i].sectionData.order == 1) {
                                operationData.form[i].sectionData.fieldSections[0].fields = parseLines_scope.repuestosArr;
                                break;
                            }
                        }
                    }
                    _.set(requestData.data, 'operationData', operationData);
                    //        _.set(requestData.data, 'repuestos', JSON.stringify(parseLines_scope.repuestosArr));
                    _.set(requestData.data, 'creatorId', $scope.usuario.codigoOperador);
                    _.set(requestData.data, 'deviceData', {
                        "enDispositivo": false
                    });
                    _.set(requestData.data, 'createdBy', $scope.usuario.codigoOperador);
                    fields = [];
                    fields.push({
                        "key": "Tipo Servicio",
                        "value": parseLines_scope["tipoServicio"]
                    });
                    fields.push({
                        "key": "Subtipo Servicio",
                        "value": parseLines_scope["subTipoServicio"]
                    });
                    _.set(requestData.data, 'serviceAntecedent', {
                        "fields": fields
                    });
                    return requestData;
                    /*CLICK TO EDIT MAPPING*/
                })($scope);
                // read more about using rest services: https://links.appery.io/ve-snippet-rest
                Apperyio.get("Tech1_WORKORDER_create_service")(requestData).then(
                    function(success) { // success callback
                        /*CLICK TO EDIT MAPPING*/
                        if (!$scope.parseLines[parseLinesIter].estWarning) {
                            $scope.contadorOk++;
                            $scope.parseLines[parseLinesIter].estCargando = false;
                            $scope.parseLines[parseLinesIter].estOk = true;
                            $scope.parseLines[parseLinesIter].estError = false;
                            $scope.parseLines[parseLinesIter].estWarning = false;
                            $scope.parseLines[parseLinesIter].codigoError = "00";
                            $scope.parseLines[parseLinesIter].textoError = "Orden cargada OK";
                            $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                        }
                        $scope.totalOrdenesNuevas++;
                        $scope.ordenesActual++;
                        if ($scope.ordenesActual >= $scope.ordenesTotal) {
                            $scope.textOrders = "";
                            $scope.textAsignaciones = "";
                            showstatusFinProc();
                        } else {
                            cargaPrevioExistenciaOrden(parseLinesIter + 1);
                        }
                    },
                    function(error) { // callback to handle request error
                        if ($scope.parseLines[parseLinesIter].estWarning)
                            $scope.contadorWarn--;
                        $scope.contadorErr++;
                        $scope.parseLines[parseLinesIter].estCargando = false;
                        $scope.parseLines[parseLinesIter].estOk = false;
                        $scope.parseLines[parseLinesIter].estError = true;
                        $scope.hayNoCargadas = true;
                        $scope.parseLines[parseLinesIter].estWarning = false;
                        $scope.parseLines[parseLinesIter].codigoError = error.data.code;
                        $scope.parseLines[parseLinesIter].textoError = (decodeErrorCodes(error.data.code) !== "" ? decodeErrorCodes(error.data.code) : error.data.description);
                        $scope.mensajeActProceso = "Orden: " + $scope.parseLines[parseLinesIter].codigo + ", Código: " + $scope.parseLines[parseLinesIter].codigoError + ", Mensaje: " + $scope.parseLines[parseLinesIter].textoError;
                        $scope.ordenesActual++;
                        if ($scope.ordenesActual >= $scope.ordenesTotal) {
                            $scope.textOrders = "";
                            $scope.textAsignaciones = "";
                            showstatusFinProc();
                        } else {
                            cargaPrevioExistenciaOrden(parseLinesIter + 1);
                        }
                    },
                    function(notify) { // notify callback, can fire few times
                    });
            };
            /**
             * @function changeNameColumns
             * @param columna
             */
            function changeNameColumns(columna) {
                if (!columna) {
                    return columna;
                }
                if ($scope.arrParseColumns[columna]) {
                    return $scope.arrParseColumns[columna];
                } else {
                    return columna;
                }
            };
            /**
             * @function formatDate1
             * @param fecha
             */
            function formatDate1(fecha) {
                if (!fecha) {
                    return fecha;
                }
                var arrFecha = fecha.split(".");
                if (arrFecha[2] == "0000") {
                    return "1900-01-01";
                } else {
                    return arrFecha[2] + "-" + arrFecha[0] + "-" + arrFecha[1];
                }
            };
            /**
             * @function decodeErrorCodes
             * @param code
             */
            function decodeErrorCodes(code) {
                if (!code) {
                    return code;
                }
                if ($scope.arrErrorCodeTranscription[code]) {
                    return $scope.arrErrorCodeTranscription[code];
                } else {
                    return "";
                }
            };
            /**
             * @function getMapLocations
             */
            function getMapLocations() {
                var locations = [];
                //$scope.customMarkers = {};
                for (var i in $scope.parseLines) {
                    loc = {};
                    loc.direccion = $scope.parseLines[i].direccion + ", " + $scope.parseLines[i].comuna + ", " + $scope.parseLines[i].ciudad + ", " + $scope.regionesDecode[$scope.parseLines[i].region];
                    loc.codigo = $scope.parseLines[i].codigo;
                    locations.push(loc);
                }
                for (var i in locations) {
                    var requestData = {
                        params: {
                            address: locations[i].direccion.trim(),
                            order: locations[i].codigo
                        }
                    };
                    Apperyio.get("GetGeoLocationFromAddress_service")(requestData).then(
                        function(success) {
                            var marker = {};
                            marker.id = success.data.results[0].place_id;
                            marker.title = success.data.results[0].formatted_address;
                            marker.coords = {};
                            marker.coords.latitude = success.data.results[0].geometry.location.lat;
                            marker.coords.longitude = success.data.results[0].geometry.location.lng;
                            $scope.customMarkers[success.config.params.order] = marker;
                        },
                        function(error) {
                            alert("Error al obtener la posición para: " + error.config.params.address + ". Deberá actualizr la dirección de forma manual posteriormente");
                            var marker = {};
                            $scope.customMarkers[error.config.params.order] = marker;
                        }
                    );
                }
            };
            /**
             * @function getAllLocationsAndChargeDB
             */
            function getAllLocationsAndChargeDB() {
                if (Object.keys($scope.customMarkers).length >= $scope.parseLines.length) {
                    cargarOrdenesCloud();
                } else {
                    setTimeout(function() {
                        getAllLocationsAndChargeDB()
                    }, 1000);
                }
            };
            /**
             * @function formatDateNow2
             * @param dias
             */
            function formatDateNow2(dias) {
                var today = new Date();
                today.setDate(today.getDate() + dias);
                var dd = today.getDate();
                var mm = today.getMonth() + 1;
                var yyyy = today.getFullYear();
                return yyyy + '-' + $scope.addZero(mm) + '-' + addZero(dd);
            };
            /**
             * @function setFechasAsignacion
             */
            $scope.setFechasAsignacion = function() {
                if ($scope.parseLines.length > 0) {
                    for (i in $scope.parseLines) {
                        $scope.parseLines[i].fechaAsignacionData = formatDate3($scope.selectFechaAsignacionModelo.toISOString());
                        $scope.parseLines[i].fechaAsignacionDataModel = $scope.selectFechaAsignacionModelo;
                    }
                }
            };
            /**
             * @function formatDate3
             * @param date
             */
            function formatDate3(date) {
                var fecha = date.split("T");
                return fecha[0];
            };
            /**
             * @function createDate1
             * @param fecha
             */
            function createDate1(fecha) {
                if (fecha) {
                    var arrFecha = fecha.split("-");
                    return new Date(arrFecha[0], arrFecha[1], arrFecha[2]);
                }
            };
            /**
             * @function existePrevio
             * @param codigo
             */
            function existePrevio(codigo) {
                for (var i in $scope.ordenesAnteriores) {
                    if ($scope.ordenesAnteriores[i].codigo == codigo) {
                        return true;
                    }
                }
                return false;
            };
            /**
             * @function existeFechaProceso
             * @param arregloDias
             * @param fecha
             */
            function existeFechaProceso(arregloDias, fecha) {
                for (var i in arregloDias)
                    if (arregloDias[i].fecha == fecha)
                        return true;
                return false;
            };
            /**
             * @function invierteFecha
             * @param fecha
             */
            function invierteFecha(fecha) {
                var a = fecha.split("-");
                return a[2] + "-" + a[1] + "-" + a[0];
            };
            /**
             * @function detenerProcesoCarga
             */
            $scope.detenerProcesoCarga = function() {
                if ($scope.mConfirm("¿Desea detener el proceso de carga de órdenes?")) {
                    $scope.detenerProcesoC = true;
                }
            };
            /**
             * @function showstatusFinProc
             */
            function showstatusFinProc() {
                $scope.mensajeActProceso = "Fin Proceso";
                $scope.statusCarga = false;
                $scope.finCargaNube = true;
                $scope.totalOkStatus = $scope.contadorOk > 0 ? true : false;
                $scope.totalErrStatus = $scope.contadorErr > 0 ? true : false;
                $scope.totalWarnStatus = $scope.contadorWarn > 0 ? true : false;
                $scope.totalOkMsg = $scope.contadorOk > 0 ? " " + $scope.contadorOk + " órdenes cargadas OK" : "";
                $scope.totalErrMsg = $scope.contadorErr > 0 ? " " + $scope.contadorErr + " órdenes con ERROR, no cargadas." : "";
                $scope.totalWarnMsg = $scope.contadorWarn > 0 ? " " + $scope.contadorWarn + " órdenes con ADVERTENCIAS" : "";
                if ($scope.totalErrStatus)
                    $scope.msgFinProceso = "Proceso finalizado con Errores";
                else if ($scope.totalWarnStatus)
                    $scope.msgFinProceso = "Proceso finalizado con Advertencias";
                else
                    $scope.msgFinProceso = "Proceso finalizado";
                $scope.msgResumenProceso =
                    "Ordenes Insertadas: " + ($scope.totalOrdenesNuevas - $scope.totalOrdenesActualizadas) + ", " +
                    "Ordenes Actualizadas: " + $scope.totalOrdenesActualizadas + ", " +
                    "Nuevas Direcciones GPS: " + $scope.totalInvocacionesGPS;
            };
            /**
             * @function readFromExcelAs
             */
            $scope.readFromExcelAs = function() {
                $scope.parseLinesAs = [];
                $scope.parseLinesAs = parseDataTableAs($scope.textAsignaciones);
            };
            /**
             * @function parseDataTableAs
             * @param dataTable
             */
            function parseDataTableAs(dataTable) {
                var parseDataReturn = [];
                var parseLines = dataTable.split("\n");
                var contadorColumnas = 0;
                var contadorBloque = 0;
                var tecnico = "";
                var id = "";
                var formatoArchivoIncorrecto = true;
                $scope.checkAssignGral = true;
                for (var i in parseLines) {
                    contadorColumnas = 0;
                    var row = {};
                    parseTabs = parseLines[i].split("\t");
                    for (var j in parseTabs) {
                        contadorColumnas++;
                        if (contadorColumnas == 3) {
                            if (parseTabs[j] === "" || isNaN(parseInt(parseTabs[j]))) {
                                if (parseTabs[j] == "OT") {
                                    formatoArchivoIncorrecto = false;
                                    contadorBloque++;
                                    tecnico = parseLines[i - 1].split("\t")[j - 1];
                                    id = parseTabs[j - 1];
                                }
                            } else {
                                row["bloque"] = contadorBloque;
                                row["codigo"] = parseTabs[j];
                                row["tecnico"] = tecnico;
                                row["id"] = id;
                                row["checkAssign"] = true;
                                parseDataReturn.push(row);
                            }
                        }
                    }
                }
                var contadorColumnas = 0;
                var contadorBloque = 0;
                var tecnico = "";
                var id = "";
                for (var i in parseLines) {
                    contadorColumnas = 0;
                    var row = {};
                    parseTabs = parseLines[i].split("\t");
                    for (var j in parseTabs) {
                        contadorColumnas++;
                        if (contadorColumnas == 12) {
                            if (parseTabs[j] === "" || isNaN(parseInt(parseTabs[j]))) {
                                if (parseTabs[j] == "OT") {
                                    formatoArchivoIncorrecto = false;
                                    contadorBloque++;
                                    tecnico = parseLines[i - 1].split("\t")[j - 1];
                                    id = parseTabs[j - 1];
                                }
                            } else {
                                row["bloque"] = contadorBloque;
                                row["codigo"] = parseTabs[j];
                                row["tecnico"] = tecnico;
                                row["id"] = id;
                                row["checkAssign"] = true;
                                parseDataReturn.push(row);
                            }
                        }
                    }
                }
                if (formatoArchivoIncorrecto) {
                    alert("El formato de carga de Asignaciones es incorrecto");
                    $scope.textAsignaciones = "";
                    return [];
                } else {
                    $scope.totalOrdenesAsignacion = parseDataReturn.length;
                    return parseDataReturn;
                }
            };
            /**
             * @function reprocesarNoCargadas
             */
            $scope.reprocesarNoCargadas = function() {
                //Recorremos el listado ParseLines y eliminamos las que ya se cargaron
                for (var i = 0; i < $scope.parseLines.length; ++i) {
                    if ($scope.parseLines[i].estOk || $scope.parseLines[i].estWarning) {
                        $scope.parseLines.splice(i, 1);
                        --i;
                    } else {
                        $scope.parseLines[i].estCargando = false;
                        $scope.parseLines[i].estOk = false;
                        $scope.parseLines[i].estError = false;
                        $scope.parseLines[i].estWarning = false;
                        $scope.parseLines[i].codigoError = "";
                        $scope.parseLines[i].textoError = "";
                    }
                }
                $scope.ordenesTotal = $scope.parseLines.length;
                $scope.ordenesActual = 0;
                $scope.finCargaNube = false;
                $scope.mensajeActProceso = "";
                $scope.statusCarga = false;
                $scope.contadorOk = 0;
                $scope.contadorWarn = 0;
                $scope.contadorErr = 0;
                $scope.totalOkStatus = false;
                $scope.totalErrStatus = false;
                $scope.totalWarnStatus = false;
                $scope.totalOkMsg = "";
                $scope.totalErrMsg = "";
                $scope.totalWarnMsg = "";
                $scope.msgFinProceso = "";
                $scope.msgResumenProceso = "";
                $scope.totalInvocacionesGPS = 0;
                $scope.totalOrdenesNuevas = 0;
                $scope.totalOrdenesActualizadas = 0;
                $scope.totalOrdenesAsignacionCoincidentes = 0;
                $scope.listaOrdenesAsignacionNoCoincidentes = "";
                $scope.hayNoCargadas = false;
                $scope.cargarOrdenes();
            };
            /**
             * @function checkAssignAll
             * @param bool
             */
            $scope.checkAssignAll = function(bool) {
                for (var i in $scope.parseLinesAs) {
                    $scope.parseLinesAs[i].checkAssign = bool;
                }
            };
            /**
             * @function validateCheckAssign
             */
            $scope.validateCheckAssign = function() {
                for (var i in $scope.parseLinesAs) {
                    if (!$scope.parseLinesAs[i].checkAssign) {
                        $scope.checkAssignGral = false;
                        return;
                    }
                }
                $scope.checkAssignGral = true;
            };
        }
    });